--script for http://yamgo.com/ (09/09/2015)

   local UpdateID='Yamgo_TV01'
   local UseLocalLogo = nil

if UseLocalLogo == nil then
   local fhandle = io.open (m_simpleTV.MainScriptDir ..  "user/tvplaylists/tvmenu.ini")   
   if fhandle == nil then 
      UseLocalLogo = '1'
      return
   end
   local str = fhandle:read('*a')
   fhandle:close()

   UseLocalLogo = string.match(str,'UseLocalLogo=(%d);')
   if UseLocalLogo == nil then UseLocalLogo = 0 end
end

if UseLocalLogo == '1' then
   local sqlstr = 'Select main.id,main.pict from main where main.updateid like "%Yamgo_%";'
   local dTable = m_simpleTV.Database.GetTable(sqlstr)
   if dTable ~= nil and dTable[1] ~= nil then
     for k, v in ipairs(dTable) do 
        --debug_in_file(v.id .. '  ' .. v.pict .. '\n')
        m_simpleTV.Database.ExecuteSql('DELETE FROM Main WHERE (Main.Id=' .. v.id .. ');',true) 
     end
   end
end
-----------------------------------------------
require('json')

 local session = m_simpleTV.WinInet.New("Opera/9.80 (Windows NT 6.1; U; ru) Presto/2.9.168 Version/11.52")
 if session == nil then return end

  --INTERNET_OPTION_CONNECT_TIMEOUT
  m_simpleTV.WinInet.SetOptionInt(session,2,5000,0)
  --INTERNET_OPTION_RECEIVE_TIMEOUT
  m_simpleTV.WinInet.SetOptionInt(session,6,8000,0)
-------------------------------------------

 m_simpleTV.OSD.ShowMessage("Yamgo: start loading playlist" ,0xFF00,3)

  local rc,answer=m_simpleTV.WinInet.Get(session,'http://yamgo.com/')
  m_simpleTV.WinInet.Close(session)

   if rc~=200 then
  	   m_simpleTV.WinInet.Close(session)
  	   m_simpleTV.OSD.ShowMessage("Connection error - " .. rc ,255,10)
  	   return
   end

--debug_in_file(answer .. '\n')

  local tmp = findpattern(answer,'var channels = (.-)};',1,15,1)
--debug_in_file(tmp .. '\n')
  if tmp == nil then
     	   m_simpleTV.OSD.ShowMessage("Yamgo error - can't find json",255,10)
   return
  end

 local t = json.decode(tmp)
 if t == nil  then
    m_simpleTV.OSD.ShowMessage("Yamgo error - can't decode json"  ,255,10)
    return
 end

 local name,adr,grp,img
 local m3ustr = '#EXTM3U\n' 

 for k,v in pairs(t) do
      for i,w in ipairs(v) do

        name = w.channel_name
        adr = w.channel_stream
        grp = w.category_name
        img = w.channel_images_logo_large

        if name ~=nil and adr ~= nil and grp ~= nil and img ~= nil then
 --debug_in_file(k ..'  ' .. grp.. '  ' .. name .. '  ' .. adr .. '\n')

          if UseLocalLogo == '1' then    
              m3ustr = m3ustr .. '#EXTINF:-1 update-code="' .. UpdateID .. grp .. name .. '" group-title="' .. grp .. '",' .. name .. '\n' .. adr .. '\n'
           elseif UseLocalLogo ~= '1' then
              m3ustr = m3ustr .. '#EXTINF:-1 update-code="' .. UpdateID .. grp .. name .. '" group-title="' .. grp .. '" tvg-logo="' .. img .. '",' .. name .. '\n' .. adr .. '\n'
          end
        end
      end
 end

--do return end

local  tmpName = m_simpleTV.Common.GetTmpName()
if tmpName == nil then return end 

 local tfile = io.open(tmpName,'w+')
 if tfile == nil then 
     os.remove(tmpName)
     return
 end

 tfile:write(m3ustr)
 tfile:close() 

  --опции  для загрузки плейлиста 
local p={}
p.TypeSourse = 1
p.DeleteBeforeLoad = 0
p.TypeSkip   = 1
p.TypeFind =   0
p.AutoSearch = 1
p.NumberM3U =  1
p.Find_Group = 1
p.TypeCoding = 1  --  -1-auto  0 - plane text  1- UTF8  2- unicode
p.BorpasFileFormat=1
p.AutoNumber = 0
p.ExtFilter = 'Yamgo'
p.ExtFilterLogo =  '..\\Channel\\logo\\extFiltersLogo\\yamgo.png'   -- the logo of extended filter (from ver. 0.4.8 b9)
p.ExtFilterLogoForce = 0
p.UpdateID=UpdateID

local err,add,ref,names = m_simpleTV.Common.LoadPlayList (tmpName,p,0,true,false)
os.remove(tmpName)


  if err==true then
     local mess = "Yamgo: playlist loading completed (New channels: " .. add .. ")"
	 if add > 0 and add < 25 then 
	    names = string.gsub(names,'%$end','\n')
		mess = mess .. '\n' .. names
	 end
	 
	 m_simpleTV.OSD.ShowMessage(mess,0x37BEDF,3) 
  end
